//////////////////////////////////////////////////////////////////////
//  JJoyStick2Obj.h   - Joy stick external module for NeatTools
//						Coded by Mike Fusco
//						Tue Feb  4 14:32:24 PST 2003
//
//						Based off of JJoyStickObj.cpp by Yuh-Jye Chang
//                      and Rob Salgado's ModuleMaker
//
//////////////////////////////////////////////////////////////////////

#if !defined( _JJoyStick2Obj_h )
#define _JJoyStick2Obj_h

//include the header files of the base class (here, JAddObj)
//
#include "JAddObj.h"

//----------------------------------------------------------------
//
//  class JJoyStick2Obj
//

class
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JJoyStick2Obj : public JAddObj { //derives from base class

  protected:

    //----------------------------------------------
    // PERSISTENCY-RELATED METHODS
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);

  public:
    enum { OUT_BUTTONNUMBER=0,OUT_FIRSTBT=1,OUT_POV=33,OUT_JOY=34,NUMBER_OF_OUTPUTS=40 };
    enum { NUMBER_OF_INPUTS=1};    

    JJoyStick2Obj(int _id = 0); //constructor 

    boolean isValid();

    virtual const char* className() const;
    virtual JObject* clone() const;

    //----------------------------------------------
    // EVENT-BROADCAST-RELATED METHODS
    virtual void engine(int n, JLinkObj& link);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    
    //----------------------------------------------
    // DISPLAY-RELATED METHODS
    virtual void paint(JGraphics g, double dx, double dy, 
                    JRegion& rgn, double scale);
    //----------------------------------------------
    // INFORMATION-RELATED METHODS
    virtual int inputType(int n);
    virtual int outputType(int n);
    virtual boolean inputAllowed(int n);
    virtual boolean outputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void addButton(JComponent *panel);

  protected:

    //----------------------------------------------
    //  DATA
    boolean doRepaint;  // flag: repaint needed
                        // if something has changed
    
    //----------------------------------------------
    //  PERSISTENT DATA

    int     outPutChannels[NUMBER_OF_OUTPUTS];

    int     clock;

    int		id;

	boolean	valid;
};

#endif
